#ifndef __UIDLGBUILDER_H__
#define __UIDLGBUILDER_H__

#pragma once

namespace DuiLib {

class UILIB_API IDialogBuilderCallback
{
public:
    virtual ~IDialogBuilderCallback();
    virtual CControlUI* CreateControl(LPCTSTR pstrClass) = 0;
};

template<class T>
class CDialogBuilderCallback : public IDialogBuilderCallback
{
	typename typedef T TypeDialog;
public:
	CDialogBuilderCallback(TypeDialog *pDialog)
	{
		m_pDialog = pDialog;
	}
	CControlUI* CreateControl(LPCTSTR pstrClass)
	{
		return m_pDialog->CreateControl(pstrClass);
	}
	TypeDialog *m_pDialog;
};

class UILIB_API CDialogBuilder
{
public:
    CDialogBuilder();
	virtual ~CDialogBuilder();
    CControlUI* Create(STRINGorID xml, LPCTSTR type = NULL, IDialogBuilderCallback* pCallback = NULL,
        CPaintManagerUI* pManager = NULL, CControlUI* pParent = NULL);
    CControlUI* Create(IDialogBuilderCallback* pCallback = NULL, CPaintManagerUI* pManager = NULL,
        CControlUI* pParent = NULL);

    CMarkup* GetMarkup();

    void GetLastErrorMessage(LPTSTR pstrMessage, SIZE_T cchMax) const;
    void GetLastErrorLocation(LPTSTR pstrSource, SIZE_T cchMax) const;
private:
    CControlUI* _Parse(CMarkupNode* parent, CControlUI* pParent = NULL, CPaintManagerUI* pManager = NULL);

    CMarkup m_xml;
    IDialogBuilderCallback* m_pCallback;
    LPCTSTR m_pstrtype;
};

} // namespace DuiLib

#endif // __UIDLGBUILDER_H__
